<?
include("html.php");

function localdate ($format, $time, $timezone)
{
	return substr(gmdate($format,$time + $timezone),0,-5).(($timezone < 0) ? '-' : '+').str_pad(abs($timezone / 36),4,"0",STR_PAD_LEFT);
}

// adds commas to a number
function commas ($str)
{
	return number_format($str,0,".",",");
}

// replace ' with '' to avoid malformed SQL queries
function sqlQuotes (&$str)
{
	$str = str_replace("'","''",stripslashes($str));
}

// remove commas, make integer
function fixInputNum (&$num)
{
	$num = round(str_replace(",","",$num));
}

// randomize the mt_rand() function
function randomize ()
{
//	not needed since PHP 4.2.0
//	mt_srand((double)microtime()*1000000);
}

// pluralize a string
function plural ($num, $plur, $sing)
{
	if ($num != 1)
		return $plur;
	else	return $sing;
}

// evaluate an SQL query, return first cell of first row
// useful for "SELECT count(*) ..." queries
function sqleval ($query)
{
	$data = mysql_fetch_row(mysql_query($query));
	return $data[0];
}

// prints a number, colored according to its positivity/negativity.
// Set nosign=1 to omit the +/-
// Encloses the text within a <span> tag
function printCNum ($amt, $prefix, $nosign)
{
	$pos = "+";
	$neg = "-";
	if ($nosign)
		$neg = $pos = "";
?>
<span class=<?
       	if ($amt < 0)
		print '"cbad">'.$neg.$prefix;
	elseif ($amt > 0)
		print '"cgood">'.$pos.$prefix;
	else	print '"cneutral">'.$prefix;
	print	commas(abs($amt));?></span><?
}

// prints a number, colored according to its positivity/negativity.
// Set nosign=1 to omit the +/-
// Use within an open HTML tag (i.e. "<td ".printCNum2(...)."</td>")
function printCNum2 ($amt, $prefix, $nosign)
{
	$pos = "+";
	$neg = "-";
	if ($nosign)
		$neg = $pos = "";
?>
class=<?
       	if ($amt < 0)
		print '"cbad">'.$neg.$prefix;
	elseif ($amt > 0)
		print '"cgood">'.$pos.$prefix;
	else	print '"cneutral">'.$prefix;
	print	commas(abs($amt));
}

// prints a number, colored according to its positivity/negativity.
// Set nosign=1 to omit the +/-
// Use within an open HTML tag (i.e. "<td ".printCNumLoan(...)."</td>")
// Shows positive loan payments in yellow instead of green
function printCNumLoan ($amt, $prefix, $nosign)
{
	$pos = "+";
	$neg = "-";
	if ($nosign)
		$neg = $pos = "";
?>
class=<?
       	if ($amt < 0)
		print '"cbad">'.$neg.$prefix;
	elseif ($amt > 0)
		print '"cwarn">'.$pos.$prefix;
	else	print '"cneutral">'.$prefix;
	print	commas(abs($amt));
}

// returns the requested networth
function getNetworth (&$user)
{
	global $config;
	$base = $config[armtrp];
	return max(0,floor(($user[armtrp] * ($config[armtrp] / $base)) + ($user[lndtrp] * ($config[lndtrp] / $base)) + ($user[flytrp] * ($config[flytrp] / $base)) + ($user[seatrp] * ($config[seatrp] / $base)) + ($user[wiztrp] * 2) + ($user[peasants] * 3) + (($user[cash] + ($user[savings] / 2) - ($user[loan] * 2)) / (5 * $base)) + ($user[land] * 500) + ($user[freeland] * 100) + ($user[food] / log(max(10,$user[food]),10) * ($config[food] / $base))));
}

function pci ($user, $race)
{
	return round(25 * (1 + $user[cashbld] / $user[land]) * $race[pci]);
}

// loads the information for the specified user number
function loadUser ($num)
{
	global $playerdb;
	return mysql_fetch_array(mysql_query("SELECT * FROM $playerdb WHERE num=$num;"));
}

// loads a user by their username
function loadUserByName ($name)
{
	global $playerdb;
	return mysql_fetch_array(mysql_query("SELECT * FROM $playerdb WHERE username='$name';"));
}

// loads the information for the specified race number
function loadRace ($race)
{
	global $racedb;
	return mysql_fetch_array(mysql_query("SELECT * FROM $racedb WHERE id=$race;"));
}

// loads the information for the specified era number
function loadEra ($era)
{
	global $eradb;
	return mysql_fetch_array(mysql_query("SELECT * FROM $eradb WHERE id=$era;"));
}

// loads the information for the specified clan number
function loadClan ($num)
{
	global $clandb;
	return mysql_fetch_array(mysql_query("SELECT * FROM $clandb WHERE num=$num;"));
}

// Loads all clan tags into an associative array
function loadClanTags ()
{
	global $clandb;
	$clans = mysql_query("SELECT num,tag FROM $clandb;");
	while ($clan = mysql_fetch_array($clans))
		$ctags["$clan[num]"] = $clan[tag];
	$ctags["0"] = "None";
	return $ctags;
}

// Loads all race names into an associative array, intended for the scorelists
function loadRaceTags ()
{
	global $racedb;
	$races = mysql_query("SELECT id,name FROM $racedb;");
	while ($race = mysql_fetch_array($races))
		$rtags["$race[id]"] = $race[name];
	return $rtags;
}

// Loads all era names, intended for the scorelists
function loadEraTags ()
{
	global $eradb;
	$eras = mysql_query("SELECT id,name FROM $eradb;");
	while ($era = mysql_fetch_array($eras))
		$etags["$era[id]"] = $era[name];
	return $etags;
}

// Example: saveUserData($users,"cash networth armtrp lndtrp flytrp seatrp etc");
function saveUserData (&$user, $data)
{
	global $playerdb, $lockdb;
	if ($lockdb)
		return;
	$items = explode(" ",$data);
	$update = "";
	$i = 0;
	while ($tmp = $items[$i++])
	{
		$data = $user[$tmp];
		if (is_numeric($data))
			$update .= "$tmp=$data";
		else
		{
			sqlQuotes($data);
			$update .= "$tmp='$data'";
		}
		if ($items[$i]) $update .= ",";
	}
	if (!mysql_query("UPDATE $playerdb SET $update WHERE num=$user[num];"))
		print "FATAL ERROR: Failed to update player data $update for user #$user[num]!<br>\n";
// Since transactions are not used, glitches can result with building/land counts. Try to fix them when they come up.
	$tmpuser = loadUser($user[num]);
	$bldtotal = $tmpuser[popbld] + $tmpuser[cashbld] + $tmpuser[trpbld] + $tmpuser[costbld] + $tmpuser[foodbld] + $tmpuser[wizbld] + $tmpuser[defbld] + $tmpuser[freeland];
	if ($tmpuser[land] != $bldtotal)
		mysql_query("UPDATE $playerdb SET land=$bldtotal WHERE num=$user[num];");
}

// Saves data for a particular user, updating their networth in the process
// MUST specify "networth" among the fields to save!
// Example: saveUserDataNet($users,"networth cash armtrp lndtrp flytrp seatrp etc");
function saveUserDataNet (&$user, $data)
{
	$user[networth] = getNetworth($user);
	return saveUserData($user, $data);
}

// Example: saveClanData($uclan,"name motd ally1 war3");
function saveClanData (&$clan, $data)
{
	global $clandb, $lockdb;
	if ($lockdb)
		return;
	$items = explode(" ",$data);
	$update = "";
	$i = 0;
	while ($tmp = $items[$i++])
	{
		$data = $clan[$tmp];
		if (is_numeric($data))
			$update .= "$tmp=$data";
		else
		{
			sqlQuotes($data);
			$update .= "$tmp='$data'";
		}
		if ($items[$i]) $update .= ",";
	}
	if (!mysql_query("update $clandb set $update where num=$clan[num];"))
		print "FATAL ERROR: Failed to update clan data $update for clan #$clan[num]!<BR>\n";
}

/* The following code is borrowed from phpBB with minor modifications */
/**
 * bbdecode/bbencode functions:
 * Rewritten - Nathan Codding - Aug 24, 2000
 * quote, code, and list rewritten again in Jan. 2001.
 * All BBCode tags now implemented. Nesting and multiple occurances should be
 * handled fine for all of them. Using str_replace() instead of regexps often
 * for efficiency. quote, list, and code are not regular, so they are
 * implemented as PDAs - probably not all that efficient, but that's the way it is.
 *
 * Note: all BBCode tags are case-insensitive.
 *
 * Removed [url=xxx][/url] and [code][/code]
 */

function bbencode($message)
{
	// pad it with a space so we can distinguish between FALSE and matching the 1st char (index 0).
	// This is important; bbencode_quote() and bbencode_list() all depend on it.
	$message = " " . $message;

	// First: If there isn't a "[" and a "]" in the message, don't bother.
	if (!(strpos($message, "[") && strpos($message, "]")))
	{
		// Remove padding, return.
		$message = substr($message, 1);
		return $message;
	}

	// [quote] and [/quote] for posting replies with quote, or just for quoting stuff.
	$message = bbencode_quote($message);

	// [list] and [list=x] for (un)ordered lists.
	$message = bbencode_list($message);

	// [b] and [/b] for bolding text.
	$message = preg_replace("/\[b\](.*?)\[\/b\]/si", "<b>\\1</b>", $message);

	// [i] and [/i] for italicizing text.
	$message = preg_replace("/\[i\](.*?)\[\/i\]/si", "<i>\\1</i>", $message);

	// [img]image_url_here[/img] code..
	$message = preg_replace("/\[img\](.*?)\[\/img\]/si", "<img src=\"\\1\" style=\"border:0\" alt=\"\">", $message);

	// added by Thrust [center] and [/center]
	$message = preg_replace("/\[center\](.*?)\[\/center\]/si", "<center>\\1</center>", $message);

	// added by Thrust [h1] and [/h1]
	$message = preg_replace("/\[h1\](.*?)\[\/h1\]/si", "<h1>\\1</h1>", $message);

	// added by Thrust [h2] and [/h2]
	$message = preg_replace("/\[h2\](.*?)\[\/h2\]/si", "<h2>\\1</h2>", $message);

	// Patterns and replacements for URL and email tags..
	$patterns = array();
	$replacements = array();

	// [url]xxxx://www.phpbb.com[/url] code..
	$patterns[0] = "#\[url\]([a-z]+?://){1}(.*?)\[/url\]#si";
	$replacements[0] = '<a href="\1\2" target="_blank">\1\2</a>';

	// [url]www.phpbb.com[/url] code.. (no xxxx:// prefix).
	$patterns[1] = "#\[url\](.*?)\[/url\]#si";
	$replacements[1] = '<a href="http://\1" target="_blank">\1</a>';

	// [email]user@domain.tld[/email] code..
	$patterns[2] = "#\[email\](.*?)\[/email\]#si";
	$replacements[2] = '<a href="mailto:\1">\1</a>';

	$message = preg_replace($patterns, $replacements, $message);

	// Remove our padding from the string..
	$message = substr($message, 1);
	return $message;

} // bbencode()

function bbdecode($message)
{
	// Undo [email]
	$message = preg_replace("#<a href=\"mailto:(.*?)\">(.*?)</a>#s", "[email]\\1[/email]", $message);

	// Undo [url] (short form)
	$message = preg_replace("#<a href=\"([a-z]+?://)(.*?)\" target=\"_blank\">(.*?)</a>#s", "[url]\\3[/url]", $message);

	// added by Thrust Undo [center]
	$message = preg_replace("#<center>(.*?)</center>#s", "[center]\\1[/center]", $message);

	// added by Thrust Undo [h1]
	$message = preg_replace("#<h1>(.*?)</h1>#s", "[h1]\\1[/h1]", $message);

	// added by Thrust Undo [h2]
	$message = preg_replace("#<h2>(.*?)</h2>#s", "[h2]\\1[/h2]", $message);

	// Undo [img]
	$message = preg_replace("#<img src=\"(.*?)\" style=\"border:0\" alt=\"\">#s", "[img]\\1[/img]", $message);

	// Undo [b] and [i]
	$message = preg_replace("#<i>(.*?)</i>#s", "[i]\\1[/i]", $message);
	$message = preg_replace("#<b>(.*?)</b>#s", "[b]\\1[/b]", $message);

	// Undo lists (unordered/ordered)
	// <li> tags:
	$message = str_replace("<li>", "[*]", $message);

	// [list] tags:
	$message = str_replace("<ul>", "[list]", $message);

	// [list=x] tags:
	$message = preg_replace("#<ol type=\"([A1])\">#si", "[list=\\1]", $message);

	// [/list] tags:
	$message = str_replace("</ul>", "[/list]", $message);
	$message = str_replace("</ol>", "[/list]", $message);

	// Undo [quote]
	$quote_start_html = "<table style=\"border:0;text-align:center;width:85%;font-size:smaller\"><tr><td>Quote:<hr></td></tr><tr><td><blockquote>";
	$quote_end_html = "</blockquote></td></tr><tr><td><hr></td></tr></table>";
	$message = str_replace($quote_start_html, "[quote]", $message);
	$message = str_replace($quote_end_html, "[/quote]", $message);

	return($message);
} // bbdecode()

/**
 * Nathan Codding - Jan. 12, 2001.
 * Performs [quote][/quote] bbencoding on the given string, and returns the results.
 * Any unmatched "[quote]" or "[/quote]" token will just be left alone.
 * This works fine with both having more than one quote in a message, and with nested quotes.
 * Since that is not a regular language, this is actually a PDA and uses a stack. Great fun.
 *
 * Note: This function assumes the first character of $message is a space, which is added by
 * bbencode().
 */
function bbencode_quote($message)
{
	// First things first: If there aren't any "[quote]" strings in the message, we don't
	// need to process it at all.

	if (!strpos(strtolower($message), "[quote]"))
	{
		return $message;
	}

	$stack = Array();
	$curr_pos = 1;
	while ($curr_pos && ($curr_pos < strlen($message)))
	{
		$curr_pos = strpos($message, "[", $curr_pos);

		// If not found, $curr_pos will be 0, and the loop will end.
		if ($curr_pos)
		{
			// We found a [. It starts at $curr_pos.
			// check if it's a starting or ending quote tag.
			$possible_start = substr($message, $curr_pos, 7);
			$possible_end = substr($message, $curr_pos, 8);
			if (strcasecmp("[quote]", $possible_start) == 0)
			{
				// We have a starting quote tag.
				// Push its position on to the stack, and then keep going to the right.
				array_push($stack, $curr_pos);
				++$curr_pos;
			}
			else if (strcasecmp("[/quote]", $possible_end) == 0)
			{
				// We have an ending quote tag.
				// Check if we've already found a matching starting tag.
				if (sizeof($stack) > 0)
				{
					// There exists a starting tag.
					// We need to do 2 replacements now.
					$start_index = array_pop($stack);

					// everything before the [quote] tag.
					$before_start_tag = substr($message, 0, $start_index);

					// everything after the [quote] tag, but before the [/quote] tag.
					$between_tags = substr($message, $start_index + 7, $curr_pos - $start_index - 7);

					// everything after the [/quote] tag.
					$after_end_tag = substr($message, $curr_pos + 8);

					$message = $before_start_tag . "<table style=\"border:0;text-align:center;width:85%;font-size:smaller\"><tr><td>Quote:<hr></td></tr><tr><td><blockquote>";
					$message .= $between_tags . "</blockquote></td></tr><tr><td><hr></td></tr></table>";
					$message .= $after_end_tag;

					// Now.. we've screwed up the indices by changing the length of the string.
					// So, if there's anything in the stack, we want to resume searching just after it.
					// otherwise, we go back to the start.
					if (sizeof($stack) > 0)
					{
						$curr_pos = array_pop($stack);
						array_push($stack, $curr_pos);
						++$curr_pos;
					}
					else
					{
						$curr_pos = 1;
					}
				}
				else
				{
					// No matching start tag found. Increment pos, keep going.
					++$curr_pos;
				}
			}
			else
			{
				// No starting tag or ending tag.. Increment pos, keep looping.,
				++$curr_pos;
			}
		}
	} // while

	return $message;

} // bbencode_quote()

/**
 * Nathan Codding - Jan. 12, 2001.
 * Performs [list][/list] and [list=?][/list] bbencoding on the given string, and returns the results.
 * Any unmatched "[list]" or "[/list]" token will just be left alone.
 * This works fine with both having more than one list in a message, and with nested lists.
 * Since that is not a regular language, this is actually a PDA and uses a stack. Great fun.
 *
 * Note: This function assumes the first character of $message is a space, which is added by
 * bbencode().
 */
function bbencode_list($message)
{
	$start_length = Array();
	$start_length[ordered] = 8;
	$start_length[unordered] = 6;

	// First things first: If there aren't any "[list" strings in the message, we don't
	// need to process it at all.

	if (!strpos(strtolower($message), "[list"))
	{
		return $message;
	}

	$stack = Array();
	$curr_pos = 1;
	while ($curr_pos && ($curr_pos < strlen($message)))
	{
		$curr_pos = strpos($message, "[", $curr_pos);

		// If not found, $curr_pos will be 0, and the loop will end.
		if ($curr_pos)
		{
			// We found a [. It starts at $curr_pos.
			// check if it's a starting or ending list tag.
			$possible_ordered_start = substr($message, $curr_pos, $start_length[ordered]);
			$possible_unordered_start = substr($message, $curr_pos, $start_length[unordered]);
			$possible_end = substr($message, $curr_pos, 7);
			if (strcasecmp("[list]", $possible_unordered_start) == 0)
			{
				// We have a starting unordered list tag.
				// Push its position on to the stack, and then keep going to the right.
				array_push($stack, array($curr_pos, ""));
				++$curr_pos;
			}
			else if (preg_match("/\[list=([a1])\]/si", $possible_ordered_start, $matches))
			{
				// We have a starting ordered list tag.
				// Push its position on to the stack, and the starting char onto the start
				// char stack, the keep going to the right.
				array_push($stack, array($curr_pos, $matches[1]));
				++$curr_pos;
			}
			else if (strcasecmp("[/list]", $possible_end) == 0)
			{
				// We have an ending list tag.
				// Check if we've already found a matching starting tag.
				if (sizeof($stack) > 0)
				{
					// There exists a starting tag.
					// We need to do 2 replacements now.
					$start = array_pop($stack);
					$start_index = $start[0];
					$start_char = $start[1];
					$is_ordered = ($start_char != "");
					$start_tag_length = ($is_ordered) ? $start_length[ordered] : $start_length[unordered];

					// everything before the [list] tag.
					$before_start_tag = substr($message, 0, $start_index);

					// everything after the [list] tag, but before the [/list] tag.
					$between_tags = substr($message, $start_index + $start_tag_length, $curr_pos - $start_index - $start_tag_length);
					// Need to replace [*] with <LI> inside the list.
					$between_tags = str_replace("[*]", "<li>", $between_tags);

					// everything after the [/list] tag.
					$after_end_tag = substr($message, $curr_pos + 7);

					if ($is_ordered)
					{
						$message = $before_start_tag . "<ol type=\"" . $start_char . "\">";
						$message .= $between_tags . "</ol>";
					}
					else
					{
						$message = $before_start_tag . "<ul>";
						$message .= $between_tags . "</ul>";
					}

					$message .= $after_end_tag;

					// Now.. we've screwed up the indices by changing the length of the string.
					// So, if there's anything in the stack, we want to resume searching just after it.
					// otherwise, we go back to the start.
					if (sizeof($stack) > 0)
					{
						$a = array_pop($stack);
						$curr_pos = $a[0];
						array_push($stack, $a);
						++$curr_pos;
					}
					else
					{
						$curr_pos = 1;
					}
				}
				else
				{
					// No matching start tag found. Increment pos, keep going.
					++$curr_pos;
				}
			}
			else
			{
				// No starting tag or ending tag.. Increment pos, keep looping.,
				++$curr_pos;
			}
		}
	} // while

	return $message;

} // bbencode_list()
/* End of code from phpBB  */

// function to return amount of land
function gimmeLand($currland, $bonus, $era)
{
	if ($era == 1)
		$multip = 1;
	elseif ($era == 2)
		$multip = 1.4;
	elseif ($era == 3)
		$multip = 1.8;

	return ceil((1 / ($currland * .00022 + .25)) * 20 * $bonus * $multip);
}

function calcSizeBonus ($networth)
{
	if ($networth <= 100000)
		$size = 0.524;
	elseif ($networth <= 500000)
		$size = 0.887;
	elseif ($networth <= 1000000)
		$size = 1.145;
	elseif ($networth <= 10000000)
		$size = 1.294;
	elseif ($networth <= 100000000)
		$size = 1.454;
	else	$size = 1.674;
	return $size;
}

function printStatsBar ()
{
	global $users, $uera, $config;
?>
<table style="width:100%">
<tr class="era<?=$users[era]?>" style="font-size:medium">
    <td class="ac"><a href="<?=$config[main]?>?action=messages"><?if (numNewMessages() > 0) print "<b>New Mail!</b>"; else print "Mailbox";?></a></td>
    <td class="ac">Turns: <?=$users[turns]?></td>
    <td class="ac">Money: $<?=commas($users[cash])?></td>
    <td class="ac">Land: <?=commas($users[land])?></td>
    <td class="ac"><?=$uera[runes]?>: <?=commas($users[runes])?></td>
    <td class="ac"><?=$uera[food]?>: <?=commas($users[food])?></td>
    <td class="ac">Health: <?=$users[health]?>%</td>
    <td class="ac">Networth: $<?=commas($users[networth])?></td></tr>
</table>
<?
}

// Take a specified number of turns performing the given action
// Valid actions (so far): cash, land, war; others will be added as necessary
function takeTurns ($numturns, $action, $condensed = 0)
{
	global $config, $trplst, $time;
	global $users, $urace, $uera, $uclan, $landgained, $cashgained, $foodgained, $warflag, $lastweek;
	if ($users[era] == 1)
	{
		$urace[ind] *= .95;
		$urace[runes] *= 1.2;
	}
	if ($users[era] == 3)
		$urace[ind] *= 1.15;

	if ($numturns > $users[turns])
		TheEnd('<span class="cbad">FATAL ERROR</span>: attempted to use more turns than available!');

	if (($action == 'cash') || ($action == 'land') || ($action == 'farm'))	// Actions which can be aborted
		$nonstop = false;
	else	$nonstop = true;

	$taken = 0;
	$deserted = 1;

	$overall[income] = $overall[expenses] = $overall[wartax] = $overall[loanpayed] = $overall[money] = 0;
	$overall[foodpro] = $overall[foodcon] = $overall[food] = 0;
	$overall[peasants] = $overall[wizards] = $overall[runes] = $overall[armtrp] = $overall[lndtrp] = $overall[flytrp] = $overall[seatrp] = 0;

	while ($taken < $numturns)					// use up specified number of turns
	{
		$taken++;
		$trouble = 0;						// bitflag - 1 for out of cash, 2 for refused loan, 4 for out of food
		$users[networth] = getNetworth($users);
		if ($action == 'land')					// exploring?
		{
			$tmp = gimmeLand($users[land],$urace[expl],$users[era]);
			$users[land] += $tmp;
			$users[freeland] += $tmp;
			$landgained += $tmp;
		}
		$size = calcSizeBonus($users[networth]);		// size bonus/penalty
		$loanrate = $config[loanbase] + $size;			// update savings and loan
		$saverate = $config[savebase] - $size;
		$users[loan] *= 1 + ($loanrate / 52 / 100);
		if ($users[turnsused] > $config[protection])		// no savings interest while under protection
			$users[savings] *= 1 + ($saverate / 52 / 100);
		$users[loan] = round($users[loan]);
		$users[savings] = round($users[savings]);
		if ($users[savings] > ($users[networth] * 100))
			$users[savings] = $users[networth] * 100;
// income
		$income = round(((pci($users,$urace) * ($users[tax] / 100) * ($users[health] / 100) * $users[peasants]) + ($users[cashbld] * 500)) / $size);
		if ($action == 'cash')					// cashing?
			$income = round($income * 1.25);

// expenses
		$expenses = round(($users[armtrp] * 1) + ($users[lndtrp] * 2.5) + ($users[flytrp] * 4) + ($users[seatrp] * 7) + ($users[land] * 8) + ($users[wiztrp] * 0.5) + ($users[food] * 0.01));
		$expbonus = (1 - $urace[costs]) + ($users[costbld] / $users[land]);
		if ($expbonus > 0.5)				// expenses bonus limit
			$expbonus = 0.5;
		$expenses -= round($expenses * $expbonus);

// war tax
		$wartax = 0;
		if ($uclan[war1])			// passive war tax
			$wartax += $networth / 100;
		if ($uclan[war2])			// applied for each clan
			$wartax += $networth / 100;
		if ($uclan[war3])			// you are at war with
			$wartax += $networth / 100;

		if ($warflag)				// active war tax
			$wartax += $expenses / 10;

// net income
		$money = $income - ($expenses + $wartax);
		$cashgained += $money;
		$users[cash] += $money;

// handle loan separately
		if ($users[cash] < 0)
			$trouble |= 1;
// simply running out of money no longer halts turns; instead, it just adds it to your loan
// but if your loan exceeds the limit (or it's in the last week, where loans are disallowed), then you're in trouble
// for emergencies, the loan limit is doubled
		if (($trouble & 1) && (($users[loan] > $users[networth] * 100) || ($lastweek)))
		{
			$trouble |= 2;
			$users[cash] = 0;
			$loanpayed = 0;
		}
		else	$loanpayed = min(round($users[loan] / 200),$users[cash]);
		$users[cash] -= $loanpayed;
		$users[loan] -= $loanpayed;
// need to include loan in net income
		$money -= $loanpayed;

// build extra units
		$armtrp = ceil(($users[trpbld] * ($users[ind_armtrp] / 100)) * 1.2 * $urace[ind] * $config[indc]);
		$users[armtrp] += $armtrp;
		$lndtrp = ceil(($users[trpbld] * ($users[ind_lndtrp] / 100)) * 0.6 * $urace[ind] * $config[indc]);
		$users[lndtrp] += $lndtrp;
		$flytrp = ceil(($users[trpbld] * ($users[ind_flytrp] / 100)) * 0.3 * $urace[ind] * $config[indc]);
		$users[flytrp] += $flytrp;
		$seatrp = ceil(($users[trpbld] * ($users[ind_seatrp] / 100)) * 0.2 * $urace[ind] * $config[indc]);
		$users[seatrp] += $seatrp;
// update food
		$foodpro = round(($users[freeland] * 10) + ($users[foodbld] * 85) * sqrt(1 - 0.75 * $users[foodbld] / $users[land]) * $urace[farms]);
		$foodcon = round((($users[armtrp] * .05) + ($users[lndtrp] * .03) + ($users[flytrp] * .02) + ($users[seatrp] * .01) + ($users[peasants] * .01) + ($users[wiztrp] * .25)) * $urace[food]);
		if ($action == 'farm')					// farming?
			$foodpro = round(1.25 * $foodpro);
		$food = $foodpro - $foodcon;
		$users[food] += $food;
		$foodgained += $food;
		if ($users[food] < 0)
		{
			$users[food] = 0;
			$trouble |= 4;
		}
// health
		if (($users[health] < 100 - (($users[tax] - 10) / 2)) && ($users[health] < 100))
			$users[health]++;
// taxes
		$taxrate = $users[tax] / 100;
		if ($users[tax] > 40)
			$taxpenalty = ($taxrate - 0.40) / 2;
		if ($users[tax] < 20)
			$taxpenalty = ($taxrate - 0.20) / 2;
// update population
		$popbase = round((($users[land] * 2) + ($users[freeland] * 5) + ($users[popbld] * 60)) / (0.95 + $taxrate + $taxpenalty));

		if ($users[peasants] != $popbase)
			$peasants = ($popbase - $users[peasants]) / 20;
		if ($peasants > 0)	$peasmult = (4 / (($users[tax] + 15) / 20)) - (7 / 9);
		if ($peasants < 0)	$peasmult = 1 / ((4 / (($users[tax] + 15) / 20)) - (7 / 9));
		$peasants = round($peasants * $peasmult * $peasmult);
		$users[peasants] += $peasants;
// gain magic energy
		$runes = 0;
		if (($users[wizbld] / $users[land]) > .15)
			$runes = mt_rand(round($users[wizbld] * 1.1),round($users[wizbld] * 1.5));
		else	$runes = round($users[wizbld] * 1.1);
		$runes = round($runes * $urace[runes]);
		$users[runes] += $runes;
// These values in the midst of adjustment
		$wizards = 0;
		if ($users[wiztrp] < ($users[wizbld] * 25))
			$wizards = $users[wizbld] * 0.45;
		elseif ($users[wiztrp] < ($users[wizbld] * 50))
			$wizards = $users[wizbld] * 0.30;
		elseif ($users[wiztrp] < ($users[wizbld] * 90))
			$wizards = $users[wizbld] * 0.15;
		elseif ($users[wiztrp] < ($users[wizbld] * 100))
			$wizards = $users[wizbld] * 0.10;
		elseif ($users[wiztrp] > ($users[wizbld] * 175))
			$wizards = $users[wiztrp] * -.05;
		$wizards = round($wizards * sqrt(1 - $wizards / max(1,abs($wizards)) * 0.75 * $users[wizbld] / $users[land]));
		$users[wiztrp] += $wizards;

		$current[income] = $income;		$overall[income] += $income;
		$current[expenses] = $expenses;		$overall[expenses] += $expenses;
		$current[wartax] = $wartax;		$overall[wartax] += $wartax;
		$current[loanpayed] = $loanpayed;	$overall[loanpayed] += $loanpayed;
		$current[money] = $money;		$overall[money] += $money;

		$current[foodpro] = $foodpro;		$overall[foodpro] += $foodpro;
		$current[foodcon] = $foodcon;		$overall[foodcon] += $foodcon;
		$current[food] = $food;			$overall[food] += $food;

		$current[peasants] = $peasants;		$overall[peasants] += $peasants;
		$current[wizards] = $wizards;		$overall[wizards] += $wizards;
		$current[runes] = $runes;		$overall[runes] += $runes;
		$current[armtrp] = $armtrp;		$overall[armtrp] += $armtrp;
		$current[lndtrp] = $lndtrp;		$overall[lndtrp] += $lndtrp;
		$current[flytrp] = $flytrp;		$overall[flytrp] += $flytrp;
		$current[seatrp] = $seatrp;		$overall[seatrp] += $seatrp;

		if ((!$condensed) || ($taken == $numturns) || (($trouble & 6) && (!$nonstop)))
		{
			if ($condensed)
				$stats = $overall;
			else	$stats = $current;
// print status report
?>
<table class="empstatus">
<tr><td style="vertical-align:top"><table>
    <tr class="inputtable"><th colspan="2">Economic Status</th></tr>
    <tr><th>Income:</th>
        <td class="cneutral">$<?=commas($stats[income])?></td></tr>
    <tr><th>Expenses:</th>
        <td class="cneutral">$<?=commas($stats[expenses])?></td></tr>
<?
			if ($stats[wartax])
			{
?>
    <tr><th>War Tax:</th>
        <td class="cneutral">$<?=commas($stats[wartax])?></td></tr>
<?			}
			if ($stats[loanpayed])
			{
?>
    <tr><th>Loan Pay:</th>
        <td <?printCNumLoan($stats[loanpayed],"$",0);?></td></tr>
<?			}
?>
    <tr><th>Net:</th>
        <td <?printCNum2($stats[money],"$",0);?></td></tr>
    </table></td>
    <td style="vertical-align:top"><table>
    <tr class="inputtable"><th colspan="2">Agricultural Status</th></tr>
    <tr><th>Produced:</th>
        <td class="cneutral"><?=commas($stats[foodpro])?></td></tr>
    <tr><th>Consumed:</th>
        <td class="cneutral"><?=commas($stats[foodcon])?></td></tr>
    <tr><th>Net:</th>
        <td <?printCNum2($stats[food],"",0);?></td></tr>
    </table></td>
    <td style="vertical-align:top"><table>
    <tr class="inputtable"><th colspan="2">Population &amp; Military Status</th></tr>
<?
			$printed = 0;
			if ($stats[peasants])
			{
				$printed++;
?>
    <tr><th><?=$uera[peasants]?>:</th>
        <td <?printCNum2($stats[peasants],"",0);?></td></tr>
<?			}
			if ($stats[wizards])
			{
				$printed++;
?>
    <tr><th><?=$uera[wiztrp]?>:</th>
        <td <?printCNum2($stats[wizards],"",0);?></td></tr>
<?			}
			if ($stats[runes])
			{
				$printed++;
?>
    <tr><th><?=$uera[runes]?>:</th>
        <td <?printCNum2($stats[runes],"",0);?></td></tr>
<?			}
			if ($stats[armtrp])
			{
				$printed++;
?>
    <tr><th><?=$uera[armtrp]?>:</th>
        <td <?printCNum2($stats[armtrp],"",0);?></td></tr>
<?			}
			if ($stats[lndtrp])
			{
				$printed++;
?>
    <tr><th><?=$uera[lndtrp]?>:</th>
        <td <?printCNum2($stats[lndtrp],"",0);?></td></tr>
<?			}
			if ($stats[flytrp])
			{
				$printed++;
?>
    <tr><th><?=$uera[flytrp]?>:</th>
        <td <?printCNum2($stats[flytrp],"",0);?></td></tr>
<?			}
			if ($stats[seatrp])
			{
				$printed++;
?>
    <tr><th><?=$uera[seatrp]?>:</th>
        <td <?printCNum2($stats[seatrp],"",0);?></td></tr>
<?			}
			if (!$printed)
			{
?>
    <tr><td colspan="2" class="ac">No changes</td></tr>
<?
			}
?>
    </table></td></tr>
</table>
<?			if (($users[tax] > 40) && ($peasants < 0))
			{
?>
<span class="cbad">Your high tax rate is angering your residents.</span><br>
<?			}
			elseif (($users[tax] < 20) && ($peasants > 0))
			{
?>
<span class="cgood">Your low tax rate is encouraging immigration.</span><br>
<?			}
			if ($trouble & 1)
			{
?>
<span class="cwarn">You have insufficient funds to maintain your empire! You rush to the World Bank to take out a loan...</span><br>
<?			}
			if ($trouble & 2)
			{
?>
<span class="cbad">The World Bank refuses your request for a loan, despite your emergency!</span><br>
<?			}
			if ($trouble & 4)
			{
?>
<span class="cbad">You have run out of food! Your people are starving!</span><br>
<?
			}
?>
<hr style="width:50%">
<?
		}
		$users[turnsused]++;
		$users[turns]--;
// only punish for refused loans or starvation
		if ($trouble & 6)
		{
			$users[peasants] = round($users[peasants] * .97);
			for ($i = 0; $i < 4; $i++)
				$users[$trplst[$i]] = round($users[$trplst[$i]] * .97);
			$users[wiztrp] = round($users[wiztrp] * .97);
			$deserted *= 1.03;
?>
<span class="cbad"><?=$condensed ? round(($deserted - 1) * 100) : 3?>% of your population and military have left!<?
			if ($nonstop)
			{
?></span><br>
<?
			}
			else
			{
?> Turns were stopped!</span><br>
<?
				break;
			}
		}
	}
	$users[idle] = $time;
	saveUserDataNet($users,"networth land freeland savings loan cash armtrp lndtrp flytrp seatrp food health peasants runes wiztrp turnsused turns idle");
	return $taken;
}

function TheEnd ($reason)	// End current action
{
	global $users, $config, $version;
?>
<?=$reason?><br>
<?
	if ($users[num])
		printStatsBar();
	HTMLendfull();
	exit;
}

function printMainStats ($user, $race, $era)
{
	global $config;
?>
<table style="width:75%">
<tr class="era<?=$user[era]?>"><th colspan="3"><?=$user[empire]?> (#<?=$user[num]?>)</th></tr>
    <tr><td style="width:40%">
    <table class="empstatus" style="width:100%">
        <tr><th>Turns</th><?              ?><td><?=$user[turns]?> (max <?=$config[maxturns]?>)</td></tr>
        <tr><th>Turns Stored</th><?       ?><td><?=$user[turnsstored]?> (max <?=$config[maxstoredturns]?>)</td></tr>
        <tr><th>Rank</th><?               ?><td>#<?=$user[rank]?></td></tr>
        <tr><th><?=$era[peasants]?></th><??><td><?=commas($user[peasants])?></td></tr>
        <tr><th>Land Acres</th><?         ?><td><?=commas($user[land])?></td></tr>
        <tr><th>Money</th><?              ?><td>$<?=commas($user[cash])?></td></tr>
        <tr><th><?=$era[food]?></th><?    ?><td><?=commas($user[food])?></td></tr>
        <tr><th><?=$era[runes]?></th><?   ?><td><?=commas($user[runes])?></td></tr>
        <tr><th>Networth</th><?           ?><td>$<?=commas($user[networth])?></td></tr>
    </table></td>
    <td style="width:20%"></td>
    <td style="width:40%">
    <table class="empstatus" style="width:100%">
        <tr><th>Era</th><?              ?><td><?=$era[name]?></td></tr>
        <tr><th>Race</th><?             ?><td><?=$race[name]?></td></tr>
        <tr><th>Health</th><?           ?><td><?=$user[health]?>%</td></tr>
        <tr><th>Tax Rate</th><?         ?><td><?=$user[tax]?>%</td></tr>
        <tr><th><?=$era[armtrp]?></th><??><td><?=commas($user[armtrp])?></td></tr>
        <tr><th><?=$era[lndtrp]?></th><??><td><?=commas($user[lndtrp])?></td></tr>
        <tr><th><?=$era[flytrp]?></th><??><td><?=commas($user[flytrp])?></td></tr>
        <tr><th><?=$era[seatrp]?></th><??><td><?=commas($user[seatrp])?></td></tr>
        <tr><th><?=$era[wiztrp]?></th><??><td><?=commas($user[wiztrp])?></td></tr>
    </table></td></tr>
</table>
<?
}

function numNewMessages ()
{
	global $messagedb, $users;
	return sqleval("SELECT COUNT(*) FROM $messagedb WHERE dest=$users[num] AND time>$users[msgtime] AND deleted=0;");
}
function numTotalMessages ()
{
	global $messagedb, $users;
	return sqleval("SELECT COUNT(*) FROM $messagedb WHERE dest=$users[num] AND deleted=0;");
}

// The final 8 arguments are optional
function addNews ($event, $src, $dest, $data0 /*, $data1, $data2, $data3, $data4, $data5, $data6, $data7, $data8*/)
{
	global $newsdb, $time, $lockdb;
	if ($lockdb)
		return;
	$data_l = "data0";
	$data_n = "$data0";

	$numargs = func_num_args();

	for ($i = 4; $i < $numargs; $i++)
	{
		$n = func_get_arg($i);
		$data_l .= ",data".($i-3);
		$data_n .= ",".$n;
	}
	mysql_query("INSERT INTO $newsdb (time,num_s,clan_s,num_d,clan_d,event,$data_l) VALUES ($time,$src[num],$src[clan],$dest[num],$dest[clan],$event,$data_n);");
}

function printNews (&$user)
{
	global $newsdb, $playerdb, $clandb, $uera, $time, $trplst;

	$news = mysql_query("SELECT time,num_s,p1.empire AS name_s,c1.name AS clan_s,p1.era AS era_s,num_d,p2.empire AS name_d,c2.name AS clan_d,p2.era AS era_d,event,data0,data1,data2,data3,data4,data5,data6,data7,data8 FROM $newsdb LEFT JOIN $playerdb AS p1 ON (num_s=p1.num) LEFT JOIN $playerdb AS p2 ON (num_d=p2.num) LEFT JOIN $clandb AS c1 ON (clan_s=c1.num) LEFT JOIN $clandb AS c2 ON (clan_d=c2.num) WHERE num_d=$user[num] AND time>$user[newstime] ORDER BY time ASC;");
	if (!mysql_num_rows($news))
		return 0;
?>
<table class="inputtable" border>
<tr><th>Time</th>
    <th colspan="2">Event</th></tr>
<?
	while ($new = mysql_fetch_array($news))
	{
?>
<tr style="vertical-align:top"><th><?
		$hours = ($time-$new[time])/3600;
		if ($hours > 24)
		{
			$days = floor($hours/24);
			print $days." days, ";
			$hours -= $days*24;
		}
		print round($hours,1)." hours ago";
?></th>
<?
		$eera = loadEra($new[era_s]);
		switch ($new[event])
		{
		case 100:
?>    <td colspan="2"><span class="cgood">You sold <?=commas($new[data1])?> <?=$uera[$trplst[$new[data0]]]?> on the market for $<?=commas($new[data3])?></span></td></tr>
<?			break;
		case 101:
?>    <td colspan="2"><span class="cgood">The winning lottery ticket number is announced. You look at your lottery ticket and it matches! You have won $<?=commas($new[data0])?>!</span></td></tr>
<?			break;
		case 102:
?>    <td><span class="cgood"><?=$new[name_s]?> (#<?=$new[num_s]?>) has sent you <?=commas($new[data0])?> <?=$uera[seatrp]?> carrying...</span></td>
    <td><?
			if ($new[data1])	print commas($new[data1])." $uera[armtrp]<br>\n";
			if ($new[data2])	print commas($new[data2])." $uera[lndtrp]<br>\n";
			if ($new[data3])	print commas($new[data3])." $uera[flytrp]<br>\n";
			if ($new[data4])	print "$".commas($new[data4])."<br>\n";
			if ($new[data5])	print commas($new[data5])." $uera[runes]<br>\n";
			if ($new[data6])	print commas($new[data6])." $uera[food]<br>\n";
?>    </td></tr>
<?			break;
		case 103:
?>    <td colspan="2"><span class="cgood">Your <?=commas($new[data1])?> <?=$uera[$trplst[$new[data0]]]?> failed to sell on the market for their price of $<?=commas($new[data2])?>; <?=commas($new[data3])?> of them have been returned to your empire.</span></td></tr>
<?			break;
		case 110:
?>    <td colspan="2"><span class="cgood">You founded <?=$new[clan_d]?>.</span></td></tr>
<?			break;
		case 111:
?>    <td colspan="2"><span class="cwarn">You disbanded <?=$new[clan_d]?>.</span></td></tr>
<?			break;
		case 112:
?>    <td colspan="2"><span class="cgood"><?
			if ($new[num_s] == $new[num_d])
				print "You";
			else	print "$new[name_s] (#$new[num_s])";
?> joined <?=$new[clan_d]?>.</span></td></tr>
<?			break;
		case 113:
?>    <td colspan="2"><span class="cwarn"><?
			if ($new[num_s] == $new[num_d])
				print "You";
			else	print "$new[name_s] (#$new[num_s])";
?> left <?=$new[clan_d]?>.</span></td></tr>
<?			break;
		case 114:
?>    <td colspan="2"><span class="cwarn"><?=$new[name_s]?> (#<?=$new[num_s]?>) removed you from <?=$new[clan_d]?>.</span></td></tr>
<?			break;
		case 115:
?>    <td colspan="2"><span class="cgood"><?=$new[name_s]?> (#<?=$new[num_s]?>) made you leader of <?=$new[clan_d]?>.</span></td></tr>
<?			break;
		case 116:
?>    <td colspan="2"><span class="cgood">You inherited leadership of <?=$new[clan_d]?>.</span></td></tr>
<?			break;
		case 117:
?>    <td colspan="2"><span class="cwarn"><?=$new[name_s]?> (#<?=$new[num_s]?>) dropped you from the disbanded <?=$new[clan_d]?>.</span></td></tr>
<?			break;
		case 118:
?>    <td colspan="2"><span class="cgood"><?=$new[name_s]?> (#<?=$new[num_s]?>) made you Assistant Leader of <?=$new[clan_d]?>.</span></td></tr>
<?			break;
		case 119:
?>    <td colspan="2"><span class="cwarn"><?=$new[name_s]?> (#<?=$new[num_s]?>) has removed you from your position as Assistant Leader of <?=$new[clan_d]?>.</span></td></tr>
<?			break;
		case 120:
?>    <td colspan="2"><span class="cgood"><?=$new[name_s]?> (#<?=$new[num_s]?>) made you a Minister of Foreign Affairs of <?=$new[clan_d]?>.</span></td></tr>
<?			break;
		case 121:
?>    <td colspan="2"><span class="cwarn"><?=$new[name_s]?> (#<?=$new[num_s]?>) has removed you from your position as Minister of Foreign Affairs of <?=$new[clan_d]?>.</span></td></tr>
<?			break;
		case 122:
?>    <td colspan="2"><span class="cwarn">By the command of <?=$new[name_s]?> (#<?=$new[num_s]?>), <?=$new[clan_s]?> has declared war on <?=$new[clan_d]?>!</span></td></tr>
<?			break;
		case 123:
?>    <td colspan="2"><span class="cgood"><?=$new[name_s]?> (#<?=$new[num_s]?>) steps forward in apology and pledges to end <?=$new[clan_s]?>'s war with <?=$new[clan_d]?>!</span></td></tr>
<?			break;
		case 124:
?>    <td colspan="2"><span class="cgood">By the request of <?=$new[name_s]?> (#<?=$new[num_s]?>), <?=$new[clan_s]?> reaches out its arms toward <?=$new[clan_d]?> in alliance!</span></td></tr>
<?			break;
		case 125:
?>    <td colspan="2"><span class="cwarn">By <?=$new[name_s]?> (#<?=$new[num_s]?>)'s order, <?=$new[clan_s]?> ceases diplomatic relations with <?=$new[clan_d]?>!</span></td></tr>
<?			break;
		case 201:
?>    <td colspan="2"><span class=<?
			if ($new[data0] < 0)
				print '"cwarn">'."You find $new[name_s] (#$new[num_s]) attempting to view your empire!";
			else	print '"cbad">'."You find another empire viewing your stats!";
?></span></td></tr>
<?			break;
		case 202:
?>    <td colspan="2"><span class=<?
			if ($new[data0] < 0)
				print '"cwarn">'."$new[name_s] (#$new[num_s]) tried to eliminate your forces!";
			else
			{
				print '"cbad">';
				if ($new[data0] == 0)
					print "1";
				else	print "3";
				print "% of your forces were eliminated by $new[name_s] (#$new[num_s])!";
			}
?></span></td></tr>
<?			break;
		case 204:
?>    <td colspan="2"><span class=<?
			if ($new[data0] < 0)
				print '"cwarn">'."You notice $new[name_s] (#$new[num_s]) trying to cause storms on your land!";
			else
			{
				print '"cbad">'."Storms have blown away ".commas($new[data2])." $uera[food] and $".commas($new[data1]);
				if ($new[data0] == 0)
					print ", though your shield protected most of your goods.";
				else	print "!";
			}
?></span></td></tr>
<?			break;
		case 205:
?>    <td colspan="2"><span class=<?
			if ($new[data0] < 0)
				print '"cwarn">'."You find $new[name_s] (#$new[num_s]) attempting to disturb your $uera[runes]!";
			else
			{
				print '"cbad">'."Lightning destroyed ".commas($new[data1])." of your $uera[runes]";
				if ($new[data0] == 0)
					print ", though your shield absorbed most of the damage.";
				else	print "!";
			}
?></span></td></tr>
<?			break;
		case 206:
?>    <td colspan="2"><span class=<?
			if ($new[data0] < 0)
				print '"cwarn">'."You find $new[name_s] (#$new[num_s]) attempting to send monsters into your empire!";
			else
			{
				print '"cbad">'."Monsters have destroyed part of your empire";
				if ($new[data0] == 0)
					print ", though your shield kept most of them out.";
				else	print "!";
			}
?></span></td></tr>
<?			break;
		case 211:
			if ($new[data0] < 0)
			{
?>    <td colspan="2"><span class="cwarn">You find <?=$new[name_s]?> (#<?=$new[num_s]?>) attempting to fight with your <?=$uera[wiztrp]?>!</span></td></tr>
<?			}
			elseif ($new[data0] == 0)
			{
?>    <td><span class="cwarn">You find <?=$new[name_s]?> (#<?=$new[num_s]?>) losing a fight with your <?=$uera[wiztrp]?>!</span></td>
    <td>You killed <?=$new[data2]?> <?=$eera[wiztrp]?>, losing <?=$new[data1]?> <?=$uera[wiztrp]?> in the process.</td></tr>
<?			}
			else
			{
?>    <td><span class="cbad">Your <?=$uera[wiztrp]?> were defeated by <?=$new[name_s]?> (#<?=$new[num_s]?>) and you lost <?=$new[data0]?> acres of land!</span></td>
    <td>You lost <?=$new[data1]?> <?=$uera[wiztrp]?>, but you managed to kill <?=$new[data2]?> of your attacker's <?=$eera[wiztrp]?>.</td></tr>
<?			}
			break;
		case 212:
?>    <td colspan="2"><span class=<?
			if ($new[data0] < 0)
				print '"cwarn">'."You find $new[name_s] (#$new[num_s]) trying to embezzle your money!";
			else
			{
				print '"cbad">'."Someone stole $".commas($new[data1])." from your treasury";
				if ($new[data0] == 0)
					print ", though your shield prevented them from stealing more.";
				else	print "!";
			}
?></span></td></tr>
<?			break;
		case 300:
?>    <td colspan="2"><span class="cwarn">Your forces came to the aid of <?=sqleval("SELECT empire FROM $playerdb WHERE num=$new[data0];")?> (#<?=$new[data0]?>) in defense from <?=$new[name_s]?> (#<?=$new[num_s]?>)!</span></td></tr>
<?			break;
		case 301:
?>    <td colspan="2"><span class="cbad">As <?=$new[name_s]?> (#<?=$new[num_s]?>) delivers their final blow, your empire collapses...</span></td></tr>
<?			break;
		case 302:
		case 303:
?>    <td><span class="cbad"><?=$new[name_s]?> (#<?=$new[num_s]?>) attacked you!</span></td>
    <td><?
			if ($new[data0])
				print "Your enemy captured $new[data0] acres of land and destroyed:<br>";
			else	print "You held your defense and your enemy was repelled, but you lost:<br>";

			if ($new[data1]) print commas($new[data1])." $uera[armtrp]<br>";
			if ($new[data2]) print commas($new[data2])." $uera[lndtrp]<br>";
			if ($new[data3]) print commas($new[data3])." $uera[flytrp]<br>";
			if ($new[data4]) print commas($new[data4])." $uera[seatrp]<br>";
			print "You managed to destroy:<br>";
			if ($new[data5]) print commas($new[data5])." $eera[armtrp]<br>";
			if ($new[data6]) print commas($new[data6])." $eera[lndtrp]<br>";
			if ($new[data7]) print commas($new[data7])." $eera[flytrp]<br>";
			if ($new[data8]) print commas($new[data8])." $eera[seatrp]<br>";
?></td></tr>
<?			break;
		case 304:
		case 305:
		case 306:
		case 307:
			switch ($new[event])
			{
			case 304:	$unit = 'armtrp';	break;
			case 305:	$unit = 'lndtrp';	break;
			case 306:	$unit = 'flytrp';	break;
			case 307:	$unit = 'seatrp';	break;
			}

?>    <td><span class="cbad"><?=$new[name_s]?> (#<?=$new[num_s]?>) attacked you!</span></td>
    <td><?
			if ($new[data0])
				print "Your enemy captured $new[data0] acres of land and destroyed:<br>";
			else	print "You held your defense and your enemy was repelled, but you lost:<br>";

			if ($new[data1]) print commas($new[data1])." $uera[$unit]<br>";
			print "You managed to destroy:<br>";
			if ($new[data2]) print commas($new[data2])." $eera[$unit]<br>";
?></td></tr>
<?			break;
		}
	}
?>
</table>
<?
	return 1;
}

function contains_profanity ($body, $words)
{
	while (list(,$word) = each($words))
	{
		$word = str_replace(
			array('1','!','|','$','4','3','7','@'),	// try to undo l33t speak
			array('i','i','i','s','a','e','t','a'),	// often used to bypass filter
			$word);
		if (preg_match('#\b('.str_replace('\*','\w*?',preg_quote($word,'#')).')\b#i',$body))
			return 1;
	}
	return 0;
}
?>
